package cz.novoj.business;

import cz.novoj.dao.UserDao;
import cz.novoj.dao.UserPropertiesDao;
import cz.novoj.model.User;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

/**
 * Some very simple user manager using DI.
 *
 * @author Jan Novotn, FG Forrest a.s. (c) 2007
 * @version $Id: $
 */
public class UserManager {
	private UserDao daoUser;
	private UserPropertiesDao<User> daoUserProperties;

	@Autowired(required = true)
	public void setDaoUser(UserDao daoUser) {
		this.daoUser = daoUser;
	}

	@Autowired(required = true)
	public void setDaoUserProperties(UserPropertiesDao<User> daoUserProperties) {
		this.daoUserProperties = daoUserProperties;
	}

	public void createUserWithProperties(User user, Map<String, String> properties) {
		User createdUser = daoUser.addUser(user.getLogin(), user.getPassword());
		for(String key : properties.keySet()) {
			daoUserProperties.addProperty(createdUser, key, properties.get(key));
		}
	}

}
