package cz.novoj.business;

import cz.novoj.dao.UserDao;
import cz.novoj.dao.UserPropertiesDao;
import cz.novoj.dao.mysql.UserDaoImpl;
import cz.novoj.dao.mysql.UserPropertiesDaoImpl;
import cz.novoj.model.User;

import java.util.Map;

/**
 * Some very simple user manager not using DI.
 *
 * @author Jan Novotn, FG Forrest a.s. (c) 2007
 * @version $Id: $
 */
public class UserManagerNoDi {

	public void createUserWithProperties(User user, Map<String, String> properties) {
		//tight coupling example
		UserDao daoUser = new UserDaoImpl();
		UserPropertiesDao daoUserProperties = new UserPropertiesDaoImpl();
		//in case we want to avoid this we have to introduce some patterns such as factory or DI

		User createdUser = daoUser.addUser(user.getLogin(), user.getPassword());
		for(String key : properties.keySet()) {
			//noinspection unchecked
			daoUserProperties.addProperty(createdUser, key, properties.get(key));			
		}
	}
}
