/*
 * SmtpMessageSender.java
 *
 * Created on 18. leden 2007, 9:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.novoj.emt;

import cz.novoj.emt.exception.SendException;
import org.springframework.mail.MailSender;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSenderImpl;

/**
 * Smtp message sender implementation.
 * 
 * @author Rodina Novotnych
 */
public class SmtpMessageSender implements IMessageSender {
	private MailSender engine;

	/** Creates a new instance of SmtpMessageSender */
    public SmtpMessageSender(String smtpServer, int smtpPort, String username, String password) {
        JavaMailSenderImpl engine = new JavaMailSenderImpl();
		engine.setHost(smtpServer);
		engine.setPort(smtpPort);
		engine.setUsername(username);
		engine.setPassword(password);
		this.engine = engine;
	}
    
    /**
     * Method sends a message with subject and body from sender to receiver.
     * Format and mean of message transport is defined in implementation.
     *  
     * @param receiver address of receiver
     * @param sender address of sender
     * @param subject subject of the message
     * @param body entire body of the message
     **/
    public void send(String receiver, String sender, String subject, String body) throws SendException {
        //send message via smtp server
		SimpleMailMessage message = new SimpleMailMessage();
		message.setFrom(sender);
		message.setTo(receiver);
		message.setSubject(subject);
		message.setText(body);
		engine.send(message);
	}
    
}
