package cz.novoj.emt.gc;

import cz.novoj.emt.BusinessObject;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

import java.lang.ref.WeakReference;

/**
 * Example of testing garbage collection of the object.
 *
 * @author Jan Novotn, FG Forrest a.s. (c) 2007
 * @version $Id: $
 */
public class BusinessObjectReleaseTest {
	private BusinessObject tested;

	@Before
	public void init() {
		tested = new BusinessObject();
	}

	@Test
	public void testGc() {
		WeakReference<BusinessObject> wr = new WeakReference<BusinessObject>(tested);
		System.gc();
		assertNotNull(wr.get());
		tested = null;
		System.gc();
		assertNull(wr.get());
	}

}
